@echo off

REM Environment variables
SET MAMELOCATION=C:\MAME
SET INPLOCATION=%MAMELOCATION%\inp
SET DOWNLOCATION=C:\MAME\inp\MARP
SET DONELOCATION=C:\MAME\inp\MARP\Done
SET SRCLOCATION=%MAMELOCATION%\src

REM Expectations:
REM Gnu's CoreUtils installed
REM http://www.gnu.org/software/coreutils/
REM Gnu's Grep installed (same location)
REM http://gnuwin32.sourceforge.net/packages/grep.htm
SET GNU=C:\Program Files\GnuWin32\bin

REM 7-Zip installation location
REM http://www.7-zip.org/download.html
SET ZIP=C:\Program Files\7-Zip\7z.exe
SET ZIPFLAGS=e -y -o%DOWNLOCATION%
SET ZIPTEST=t
SET ZIPLIST=l -slt

REM Rich Paso's HEXDump copied to MAMELOCATION
REM http://www.richpasco.org/utilities/hexdump.html
REM -or-
REM XD: https://www.fourmilab.ch/xd/
REM SET HEXDUMP=hexdump.exe
REM SET HEXDUMPFLAGS=
SET HEXDUMP=xd.exe
SET HEXDUMPFLAGS=-c

REM DOS Box installed
REM http://www.dosbox.com/download.php?main=1
SET DOSBOXEXE=C:\Program Files\DOSBox-0.74\DOSBox.exe
REM Default DOS Box configuration copied to:
SET DOSBOXCONF=%MAMELOCATION%\dosbox.conf

REM The output will be recorded in:
SET LOG=%MAMELOCATION%\CHECK.TXT
ECHO Starting %0 on %DATE% at %TIME%>%LOG%
ECHO.>>%LOG%

REM Junk information can go in:
SET TEMPFILE=Tempfile.txt
SET TEMPFILE2=Tempfile2.txt
SET TEMPFILE3=Tempfile3.txt


REM Get current working directory
cd>%MAMELOCATION%\%TEMPFILE%
SET /P CWD=<%MAMELOCATION%\%TEMPFILE%

REM Extract the zip file
"%ZIP%" %ZIPFLAGS% %DOWNLOCATION%\*.zip >NUL 2>&1
ECHO Zip test>>%LOG%
ECHO ---->>%LOG%
"%ZIP%" %ZIPTEST% %DOWNLOCATION%\*.zip>>%LOG%
ECHO ---->>%LOG%
ECHO.>>%LOG%
ECHO Zip list>>%LOG%
ECHO ---->>%LOG%
"%ZIP%" %ZIPLIST% %DOWNLOCATION%\*.zip>>%LOG%
ECHO ---->>%LOG%
ECHO.>>%LOG%
cd "%DOWNLOCATION%"
RENAME *.inp %2.inp >NUL 2>&1
RENAME *.wlf %2.wlf >NUL 2>&1
cd %CWD%
MOVE "%DOWNLOCATION%\%2.inp" "%INPLOCATION%\" >NUL 2>&1
IF EXIST "%DOWNLOCATION%\%2.wlf" MOVE "%DOWNLOCATION%\%2.wlf" "%INPLOCATION%\"

REM Work out the version of MAME
SET MEXE=%1
SET MVER=%1
IF "%MVER:~2,1%" == "b" GOTO MVERTHIRD
IF "%MVER:~2,1%" == "u" GOTO MVERTHIRD
IF "%MVER:~3,1%" == "u" GOTO MVERFOURTH
GOTO MVERNUMERIC

REM 91u1, for example
:MVERTHIRD
SET MVER=%MVER:~0,2%
GOTO MVERNUMERIC

REM 102u1, for example
:MVERFOURTH
SET MVER=%MVER:~0,3%
GOTO MVERNUMERIC

:MVERNUMERIC
ECHO MAME Major Version %MVER%
ECHO MAME Major Version %MVER%>>%LOG%
ECHO.>>%LOG%

REM Default to no -nvram_directory paramater
SET NVRAM=

REM Determine NVRAM options
IF %MVER% GTR 135 GOTO NVRAM
GOTO NONVRAM

:NVRAM
SET NVRAM=-nvram_directory NUL

:NONVRAM
IF NOT EXIST "%INPLOCATION%\%2.inp" GOTO MISSINGINP

REM Determine INP options
IF %MVER% GTR 100 GOTO WITHINP
SET INPNAME=%2
GOTO NOINP

:WITHINP
SET INPNAME=%2.inp

:NOINP
REM Determine game options
IF "%3" == "" GOTO DEFAULTGAME
SET GAME=%3
GOTO HAVEGAME

:DEFAULTGAME
SET GAME=%2

:HAVEGAME
REM Backup current configuration for game
if exist cfg\%GAME% move cfg\%GAME% cfg\%GAME%.dir
if exist cfg\%GAME%.cfg move cfg\%GAME%.cfg cfg\%GAME%.bak
if exist hi\%GAME% move hi\%GAME% hi\%GAME%.dir
if exist hi\%GAME%.hi move hi\%GAME%.hi hi\%GAME%.bak
if exist nvram\%GAME% move nvram\%GAME% nvram\%GAME%.dir
if exist nvram\%GAME%.nv move nvram\%GAME%.nv nvram\%GAME%.bak
if exist diff\%GAME% move diff\%GAME% diff\%GAME%.dir
if exist diff\%GAME%.dif move diff\%GAME%.dif diff\%GAME%.bak

IF %MVER% GTR 37 GOTO WINDOWS
REM Use DOSBox
SET MAMEEXE=M%MEXE%.EXE
IF NOT EXIST %MAMEEXE% GOTO WINDOWS
COPY %DOSBOXCONF% TEMP.CONF
echo MOUNT C: %MAMELOCATION%>>TEMP.CONF
echo C:>>TEMP.CONF
echo %MAMEEXE% %GAME% -fs 0 -playback %GAME% -soundcard 1 %3 %4 %5 %6 %7 %8 %9>>TEMP.CONF
echo exit>>TEMP.CONF
GOTO RUNDOSBOX

:RUNDOSBOX
"%DOSBOXEXE%" -conf TEMP.CONF
GOTO CLEANUP

:WINDOWS
SET MAMEEXE=mame%MEXE%.EXE
IF NOT EXIST %MAMEEXE% GOTO MISSINGMAME
ECHO What MAME thinks:>>%LOG%
ECHO ---->>%LOG%
IF %MVER% GTR 84 GOTO WITHIV
REM Check for early WolfMAMEs with mameplib.dll requirement
REM Assumes the relevant mameplib.dll will exist as mamep<ver>lib.dll like the newer ones.
IF %MVER% GTR 82 GOTO PLIBDONE
IF EXIST mameplib.dll DEL mameplib.dll
SET MLIB=mamep%MVER%lib.dll
IF EXIST %MLIB% COPY %MLIB% mameplib.dll

:PLIBDONE
echo Starting MAME - you may need to press a key for older versions
%MAMEEXE% -w -nomax -nothrottle -playback %INPNAME% %GAME% %4 %5 %6 %7 %8 %9 %NVRAM%| find /v "INPVIEW" | find /v "OpenGL" | "%GNU%\tee.exe" -a %LOG%
GOTO CLEANUPWIN

:WITHIV
echo Starting MAME - you may need to press a key for older versions
%MAMEEXE% -w -nomax -nothrottle -iv 1 -playback %INPNAME% %GAME% %4 %5 %6 %7 %8 %9 %NVRAM%| find /v "INPVIEW" | find /v "OpenGL" | "%GNU%\tee.exe" -a %LOG%
GOTO CLEANUPWIN

:CLEANUPWIN
ECHO ---->>%LOG%
ECHO.>>%LOG%
IF EXIST "%INPLOCATION%\%GAME%.wlf" GOTO WLFVIEW
GOTO CLEANUPWIN2

:WLFVIEW
ECHO Checking with Wlfview
ECHO.>>%LOG%
ECHO What wlfview thinks:>>%LOG%
echo ---->>%LOG%
wlfview%MVER%.exe "%INPLOCATION%\%GAME%.wlf" "%INPLOCATION%\%GAME%.inp">>%LOG%
echo ---->>%LOG%
GOTO CLEANUPWIN2


:CLEANUPWIN2
ECHO.>>%LOG%
ECHO Source driver:>>%LOG%
SET SOURCEFILE=
IF %MVER% GTR 99 GOTO LISTNEWSOURCE
ECHO Extracting source knowledge (pre-99)
%MAMEEXE% -listsourcefile %GAME%
%MAMEEXE% -listsourcefile %GAME%>>%LOG%
%MAMEEXE% -listsourcefile %GAME%| "%GNU%\cut.exe" "-d " -f2->%TEMPFILE%
GOTO SOURCECLEAN

:LISTNEWSOURCE
ECHO Extracting source knowledge (100+)
%MAMEEXE% -listsource %GAME%
%MAMEEXE% -listsource %GAME%>>%LOG%
%MAMEEXE% -listsource %GAME%| "%GNU%\cut.exe" "-d " -f2->%TEMPFILE%

:SOURCECLEAN
SET /P SOURCEFILE=<%TEMPFILE%
FOR /f "tokens=* delims= " %%a in ("%SOURCEFILE%") DO SET SOURCEFILE=%%a
IF "%SOURCEFILE%" == "" GOTO NOSOURCE
REM Remove any directory structure
echo %GNU%\basename.exe" %SOURCEFILE% 
"%GNU%\basename.exe" %SOURCEFILE% >%TEMPFILE%
SET /P SOURCEFILE=<%TEMPFILE%

IF EXIST %SRCLOCATION%\%SOURCEFILE% GOTO TYPESRC
ECHO DIP Info from source not acquired (%SRCLOCATION%\%SOURCEFILE%).>>%LOG%
ECHO.>>%LOG%
GOTO HEXDUMP

:NOSOURCE
ECHO -listsource/-listsourcefile option failed to indicate for %GAME%
GOTO HEXDUMP

:TYPESRC
ECHO DIP Info from source:>>%LOG%
ECHO ---->>%LOG%
TYPE %SRCLOCATION%\%SOURCEFILE%>>%LOG%
ECHO ---->>%LOG%
ECHO.>>%LOG%

GOTO HEXDUMP

:HEXDUMP
ECHO Generating hexdump sections
SET INPNAME=%INPLOCATION%\%2.inp
REM HEX Dump the header, middle and tail
%HEXDUMP% %INPNAME% | "%GNU%\wc.exe" -l >%TEMPFILE%
SET /P LINES=<%TEMPFILE%
REM Work out half-way plus ten lines
SET /a LINES=(%LINES%/2+10)

%HEXDUMP% %HEXDUMPFLAGS% %INPNAME% >%TEMPFILE%
REM Dump first 20 lines of hex
echo - Head
echo Header:>>%LOG%
echo ---->>%LOG%
"%GNU%\head.exe" -n 21 %TEMPFILE% | "%GNU%\tail.exe" -n 20>>%LOG%
echo ---->>%LOG%

REM Dump mid 20 lines of hex
echo.>>%LOG%
echo - Mid
echo Mid-section:>>%LOG%
echo ---->>%LOG%
"%GNU%\head.exe" -n %LINES% %TEMPFILE% | "%GNU%\tail.exe" -n 20>>%LOG%
echo ---->>%LOG%

REM Dump last 20 lines of hex
echo.>>%LOG%
echo - Tail
echo Tail-end:>>%LOG%
echo ---->>%LOG%
"%GNU%\tail.exe" -n 20 %TEMPFILE% >>%LOG%
echo.>>%LOG%
echo ---->>%LOG%
GOTO MAMEINFODAT

:MAMEINFODAT
IF NOT EXIST %MAMELOCATION%\MAMEINFO.DAT GOTO CLEANUP

REM ToDo: Try to extract the history from MAMEInfo
ECHO.>>%LOG%
ECHO.>>%LOG%
ECHO MAME Info>>%LOG%
REM Use mame.exe -listclones <game>
%MAMEEXE% -listclones %GAME%| "%GNU%\grep.exe" -v "Clone"| "%GNU%\wc.exe" -l | "%GNU%\head.exe" -n1 >%TEMPFILE%
MOVE %TEMPFILE% %TEMPFILE2%
"%GNU%\cut.exe" "-d " -f2- "%TEMPFILE2%"  >%TEMPFILE%
SET /P NUMCLONES=<%TEMPFILE%
REM Assume this is the parent initially
SET PARENT=%GAME%
REM If only one line, this is the parent (no clones)
IF %NUMCLONES% EQU 0 GOTO HAVEPARENT
REM If more than two lines, this is the parent.
IF %NUMCLONES% GTR 1 GOTO HAVEPARENT
GOTO CHECKPARENT

:CHECKPARENT
REM If only one line, the parent is in the second column.
%MAMEEXE% -listclones %GAME%| "%GNU%\grep.exe" -v "Clone"| "%GNU%\head.exe" -n1 >%TEMPFILE%
SET /P CLONEINFO=<%TEMPFILE%
echo %CLONEINFO% | "%GNU%\cut.exe" "-d " -f2->%TEMPFILE%
SET /P CLONEINFO=<%TEMPFILE%
FOR /f "tokens=* delims= " %%a in ("%CLONEINFO%") DO SET CLONEINFO=%%a
ECHO %GAME% is clone of: %CLONEINFO%>>%LOG%
REM Right-trim the clone info
SET CLONEINFO=%CLONEINFO%##
SET CLONEINFO=%CLONEINFO:      ##=##%
SET CLONEINFO=%CLONEINFO:     ##=##%
SET CLONEINFO=%CLONEINFO:    ##=##%
SET CLONEINFO=%CLONEINFO:   ##=##%
SET CLONEINFO=%CLONEINFO:  ##=##%
SET CLONEINFO=%CLONEINFO: ##=##%
SET CLONEINFO=%CLONEINFO:##=%
SET PARENT=%CLONEINFO%
GOTO HAVEPARENT

:HAVEPARENT
REM Search MAMEInfo.dat for a line beginning $info=<parent>
REM This section completes with a single line $end
ECHO MAMEInfo.dat entries: %PARENT% and %SOURCEFILE%>>%LOG%
ECHO ---->>%LOG%
ECHO Search MAMEInfo.dat for %PARENT%
"%GNU%\grep.exe" -n "\$info=%PARENT%" mameinfo.dat | "%GNU%\cut.exe" "-d:" -f1 >%TEMPFILE2%
"%GNU%\grep.exe" -n "\$info=%PARENT%" mameinfo.dat >%TEMPFILE3%
IF "%PARENT%" == "%GAME%" GOTO MAMEINFOSOURCE
ECHO Search MAMEInfo.dat for %GAME%
"%GNU%\grep.exe" -n "\$info=%GAME%" mameinfo.dat | "%GNU%\cut.exe" "-d:" -f1 >>%TEMPFILE2%
"%GNU%\grep.exe" -n "\$info=%GAME%" mameinfo.dat >>%TEMPFILE3%
:MAMEINFOSOURCE
ECHO Search MAMEInfo.dat for %SOURCEFILE%
"%GNU%\grep.exe" -n "\$info=%SOURCEFILE%" mameinfo.dat | "%GNU%\cut.exe" "-d:" -f1 >>%TEMPFILE2%
"%GNU%\grep.exe" -n "\$info=%SOURCEFILE%" mameinfo.dat >>%TEMPFILE3%
"%GNU%\sort.exe" -u %TEMPFILE2% >%TEMPFILE%
"%GNU%\sort.exe" -u %TEMPFILE3% >%TEMPFILE2%
"%GNU%\cut.exe" "-d=" -f2- %TEMPFILE2%>%TEMPFILE3%
ECHO MAMEInfo.dat entries for:>>%LOG%
TYPE %TEMPFILE3%>>%LOG%
ECHO ---->>%LOG%
REM Now have the line numbers of relevant information in %TEMPFILE%
SET PREVLINE=0

:CYCLELINENUMS
"%GNU%\wc.exe" -l %TEMPFILE% | "%GNU%\cut.exe" "-d " -f1 | "%GNU%\head.exe" -n1 >%TEMPFILE3%
SET /P TOGO=<%TEMPFILE3%
IF %TOGO% EQU 0 GOTO CLEANUP
SET /P LINENUM=<%TEMPFILE%
DEL %TEMPFILE2% >NUL 2>&1
MOVE %TEMPFILE% %TEMPFILE2%
"%GNU%\tail.exe" -n+2 %TEMPFILE2%>%TEMPFILE%
REM Skip the file formatting lines
SET /A LINENUM=%LINENUM%+2
"%GNU%\tail.exe" -n+%LINENUM% mameinfo.dat>%TEMPFILE2%
REM Redirect cut's error output to nul as it will whinge when head cuts off the pipe.
"%GNU%\grep.exe" -n "\$end" %TEMPFILE2% | "%GNU%\cut.exe" "-d:" -f1 2>nul | "%GNU%\head.exe" -n1 >%TEMPFILE3%
SET /P LINENUM=<%TEMPFILE3%
REM Don't include the $end line
SET /A LINENUM=%LINENUM%-1
"%GNU%\head.exe" -n%LINENUM% %TEMPFILE2%>>%LOG%
echo ---->>%LOG%
GOTO CYCLELINENUMS

:CLEANUP
if exist cfg\%GAME%.dir move cfg\%GAME%.dir cfg\%GAME%
if exist cfg\%GAME%.bak move cfg\%GAME%.bak cfg\%GAME%.cfg
if exist hi\%GAME%.dir move hi\%GAME%.dir hi\%GAME%
if exist hi\%GAME%.bak move hi\%GAME%.bak hi\%GAME%.hi
if exist nvram\%GAME%.dir move nvram\%GAME%.dir nvram\%GAME%
if exist nvram\%GAME%.bak move nvram\%GAME%.bak nvram\%GAME%.nv
if exist diff\%GAME%.dir move diff\%GAME%.dir diff\%GAME%
if exist diff\%GAME%.bak move diff\%GAME%.bak diff\%GAME%.dif
if exist %INPLOCATION%\%2.inp del %INPLOCATION%\%2.inp
if exist %INPLOCATION%\%2.wlf del %INPLOCATION%\%2.wlf
if exist %TEMPFILE% del %TEMPFILE%
if exist %TEMPFILE2% del %TEMPFILE2%
if exist %TEMPFILE3% del %TEMPFILE3%
del %DOWNLOCATION%\*.png>NUL 2>&1
move "%DOWNLOCATION%\*.zip" "%DONELOCATION%\"
start notepad %LOG%
GOTO EOF

:MISSINGINP
echo INP not found for %2
GOTO EOF

:MISSINGMAME
echo MAME executable (%MAMEEXE%) not found.
GOTO EOF

:EOF
